/*
 * My van is^W^Wsemaphores are fast, fool!
 */
#include "../kern/linux-2.4.17-usersem/include/asm/unistd.h"
#include <errno.h>

#define	__NR_FS_create		226
#define	__NR_FS_down		227
#define	__NR_FS_up		228

#include "usersem.h"

static _syscall1(int,FS_create,struct fast_sem*,sem);
static _syscall1(int,FS_down,struct fast_sem*,sem);
static _syscall1(int,FS_up,struct fast_sem*,sem);

/* quick lock -- return non-zero if slow-path required */
static __inline__ int __down(int *c)
{
	int r;
	__asm__ __volatile__ (
	"	xor %0,%0\n"
	"	lock; decl %1\n"
	"	jns 1f\n"
	"	incl %0\n"
	"1:\n"
		: "=q"(r), "=m"(*c)
	);
	return r;
}

/* quick unlock -- return non-zero if slow-path required */
static __inline__ int __up(int *c)
{
	int r;
	__asm__ __volatile__ (
	"	xor %0,%0\n"
	"	lock; incl %1\n"
	"	jg 1f\n"
	"	incl %0\n"
	"1:\n"
		: "=q"(r), "=m"(*c)
	);
	return r;
}


int fs_create(struct fast_sem *sem)
{
	sem->count = 1;
	return FS_create(sem);
}

int fs_down(struct fast_sem *sem)
{
	if(!__down(&sem->count))
		return 0;
	return FS_down(sem);
}

int fs_up(struct fast_sem *sem)
{
	if(!__up(&sem->count))
		return 0;
	return FS_up(sem);
}
